searchNodes=[{"ref":"ExFlow.html","title":"ExFlow","type":"module","doc":"Module to make life with workflows easier Helps to compose functions with |&gt; to not handle errors explicitly but just to bypass them. If you hate making names for variables with Kernel.SpecialForms.with/1 this module is for you defmodule MyModule do import ExFlow def action do workflow do validate_input_data(params) ~&gt; save_user ~&gt; generate_plans(2) ~&gt;&gt; send_confirmation ~&gt; redirect_to_user_page end end end Operations in previous example might be anything. It&#39;s a bogus code to show how to to pipe operations inside workflows and not care about failures. ~&gt; is for operations which transform data and ~&gt;&gt; is for operations which don&#39;t transform data and can be built manually without metaprogramming with the help of ExFlow.bind/1, ExFlow.bind/2, ExFlow.then/1 and ExFlow.then/2."},{"ref":"ExFlow.html#bind/1","title":"ExFlow.bind/1","type":"function","doc":"Binds an argument and produces one-argument function Returns new anonymous function which either returns input parameter if it looks like error or calls the function being bound with that parameter. Inspired by &gt;&gt;= in Haskell. Parameter is considered to be error if it is equal to :error or a tuple which first element is :error. Helps to compose functions with |&gt; to not handle errors explicitly but just to bypass them. ## Examples iex&gt; ExFlow.bind(fn _ -&gt; 42 end).({:error, :reason}) {:error, :reason} iex&gt; ExFlow.bind(fn _ -&gt; 42 end).(:error) :error iex&gt; ExFlow.bind(&amp; &amp;1).(42) 42 iex&gt; {:error, :reason} |&gt; ExFlow.bind(&amp;(&amp;1 * 2)) |&gt; ExFlow.bind(&amp;(&amp;1 + 2)) {:error, :reason} iex&gt; :error |&gt; ExFlow.bind(&amp;(&amp;1 * 2)) |&gt; ExFlow.bind(&amp;(&amp;1 + 2)) :error iex&gt; 20 |&gt; ExFlow.bind(&amp;(&amp;1 * 2)) |&gt; ExFlow.bind(&amp;(&amp;1 + 2)) 42"},{"ref":"ExFlow.html#bind/2","title":"ExFlow.bind/2","type":"function","doc":""},{"ref":"ExFlow.html#then/1","title":"ExFlow.then/1","type":"function","doc":"Binds an argument and produces one-argument function which ignores function return value Returns new anonymous function which either returns input parameter if it looks like error or calls the function being bound with that parameter and returns that very parameter. Usefull for sideffect functions which don&#39;t transform input e.g. scheduling job to send email when user is created/ Inspired by &gt;&gt; in Haskell. Parameter is considered to be error if it is equal to :error or a tuple which first element is :error. Helps to compose functions with |&gt; to not handle errors explicitly but just to bypass them. ## Examples iex&gt; ExFlow.then(fn a -&gt; a + 2 end).({:error, :reason}) {:error, :reason} iex&gt; ExFlow.then(fn a -&gt; a + 2 end).(:error) :error iex&gt; ExFlow.then(&amp; &amp;1).(42) 42 iex&gt; {:error, :reason} |&gt; ExFlow.then(&amp;(&amp;1 * 2)) |&gt; ExFlow.then(&amp;(&amp;1 + 2)) {:error, :reason} iex&gt; :error |&gt; ExFlow.then(&amp;(&amp;1 * 2)) |&gt; ExFlow.then(&amp;(&amp;1 + 2)) :error iex&gt; 20 |&gt; ExFlow.then(&amp;(&amp;1 * 2)) |&gt; ExFlow.then(&amp;(&amp;1 + 2)) 20"},{"ref":"ExFlow.html#then/2","title":"ExFlow.then/2","type":"function","doc":""},{"ref":"ExFlow.html#workflow/1","title":"ExFlow.workflow/1","type":"macro","doc":"Creates workflow In simple words helps to compose functions thinking only about happy path and return error as soon as possible. Actually speaking it is the same as Kernel.SpecialForms.with/1 but doesn&#39;t make you think about the errors and allows just to write the transformations on data instead. It uses ~&gt; operator which is the same as |&gt; in context of workflow. So workflow do operation ~&gt; operation2 end is the same as operation |&gt; ExFlow.bind(&amp;(operation2(&amp;1))) Also uses ~&gt;&gt; operator where is the same as |&gt; in context of workflow but ignores the return or right parameter function. So workflow do operation ~&gt;&gt; operation2 end is the same as operation |&gt; ExFlow.then(&amp;(operation2(&amp;1))) which will return the result of operation not operation2. Useful for side-effect oe async operations which shouldn&#39;t transform input data"}]